diff --git a/shaders/shader.vert b/shaders/shader.vert
index 840711c..f5c8077 100644
--- a/shaders/shader.vert
+++ b/shaders/shader.vert
@@ -1,7 +1,6 @@
 #version 450
 
 layout(binding = 0) uniform UniformBufferObject {
-    mat4 model;
     mat4 view;
     mat4 proj;
 } ubo;
@@ -10,11 +9,16 @@ layout(location = 0) in vec3 inPosition;
 layout(location = 1) in vec3 inColor;
 layout(location = 2) in vec2 inTexCoord;
 
+layout(location = 3) in mat4 inModel;
+layout(location = 7) in uint inEnableTexture;
+
 layout(location = 0) out vec3 fragColor;
 layout(location = 1) out vec2 fragTexCoord;
+layout(location = 2) flat out uint enableTexture;
 
 void main() {
-    gl_Position = ubo.proj * ubo.view * ubo.model * vec4(inPosition, 1.0);
+    gl_Position = ubo.proj * ubo.view * inModel * vec4(inPosition, 1.0);
     fragColor = inColor;
     fragTexCoord = inTexCoord;
+    enableTexture = inEnableTexture;
 }
